# frozen_string_literal: true
config = YAML.safe_load(ERB.new(IO.read(Rails.root + 'config' + 'redis.yml')).result)[Rails.env].with_indifferent_access
redis_config = config.merge(thread_safe: true)

Sidekiq::Logging.logger.level = Logger::WARN if ENV['RAILS_ENV'] == 'production'

redis_conn = { url: "redis://#{config[:host]}:#{config[:port]}/" }

Sidekiq.configure_server do |s|
  # s.redis = redis_conn
  s.redis = redis_config
end

Sidekiq.configure_client do |s|
  # s.redis = redis_conn
  s.redis = redis_config
end