# frozen_string_literal: true
namespace :rdms do
  namespace :crc_1280_collection do
    desc "Create CRC 1280 Collection Types and CRC 1280 Collection"
    task create: :environment do
      crc_collection_title = ENV.fetch('CRC_1280_COLLECTION', "CRC 1280")
      collection_type = Hyrax::CollectionType.find_or_create_by(title: crc_collection_title)
      collection_type_gid = "gid://hyrax3-app/Hyrax::CollectionType/#{collection_type.id}"

      crc_1280_collections = collection_type.collections.select{ |t| t.title == [crc_collection_title] }

      unless crc_1280_collections.any?
        collection = Hyrax.config.collection_class.create(title: [crc_collection_title], source:[SecureRandom.uuid], collection_type_gid: collection_type_gid)

        admin_user = User.find_by(email: 'admin@hyrax')
        collection.apply_depositor_metadata(admin_user.user_key)
        collection.save
        Hyrax::Collections::PermissionsCreateService.create_default(collection: collection, creating_user: admin_user, grants: [])
      end
    end
  end
end